#ifndef LIBSW_API_PERM__H
#define LIBSW_API_PERM__H
#include <stdint.h>
#include "libsw_handle.h"

typedef enum {
  LIBSW_OPR_OTHER = 0,           /* Unspecified operation */
  LIBSW_OPR_HIDE,                /* Change Hide/unhide status of current object */
  LIBSW_OPR_LOCK,                /* Change Lock/unlock status of current object */
  LIBSW_OPR_PACKET,              /* Send/Recieve packet operation */
  LIBSW_OPR_ENABLE,              /* Enable/disable (iface only) operation */
  LIBSW_OPR_VLAN_MEMBERSHIP,     /* Change VLAN membership operation */
  LIBSW_OPR_MACTABLE,            /* MAC TABLE operation */
  LIBSW_OPR_ACL,                 /* Change ACL operation */
  LIBSW_OPR_STP,                 /* Change STP param's operation */
  LIBSW_OPR_IGMPSNOOP,           /* Change IGMP snooping param's operation */
  LIBSW_OPR_IPIFACE,             /* Change IP iface param's operation */
  LIBSW_OPR_IPROUTE,             /* Change IP route param's operation */
} libsw_operation_t;

#define CHECK_OBJ_PERM(obj, opr) \
  if (libsw_check_perm(lsw, (const libsw_obj_t*)(obj), opr)) \
     return LIBSW_NOT_ALLOWED;

int libsw_check_perm(libsw_t *lsw, const libsw_obj_t *obj, libsw_operation_t opr);
int libsw_set_obj_lock(libsw_t *lsw, libsw_obj_t* obj, uint8_t lock);


#endif
