#ifndef LIBSW_HANDLE__H
#define LIBSW_HANDLE__H

#include "libsw_debug.h"
#include "libsw_types.h"
#include "libsw_driver.h"

typedef struct
{
  const iface_desc_t *iface;
  void *handle;
} libsw_libsfp_data_t;

typedef struct
{
  /* log object */
  dbg_desc_t log;

  /* libsfp handle & data */
  libsw_libsfp_data_t sfp;

  /* parameters from libsw -> hw module */
  libsw_hwprm_t prm;

  /* hw module data */
  void *hwdata;
  switch_hw_t *hw;
  void *dllhandle;

  /* DBs */
  libsw_db_api_t *dbapi;
  libsw_db_t *mac_db;

} libsw_t;

#define LIBSW_HW_HANDLE(lsw) lsw->hwdata

#endif
